#include <string.h>

#define serbuflen 50 //total length of single line of input 
#define nounnum 4 //number of nouns (parameters)

char serbuf[serbuflen+1];   //buffer for storing serial input text
char* verb;                 //stores command text
char* noun[nounnum]; //stores pointers to parameters
byte nouns;
const char delim[2] = " ";

void serialControl(){
  byte slen=0;
  bool getline=1;
  bool ok=0;                          //checks if is bad command or not
  while(getline){
    if(Serial.available()){
      serbuf[slen] = Serial.read();
      if(serbuf[slen]==13){getline=0;}
      if(serbuf[slen]==8){slen-=2;if(slen==254){slen++;}else{Serial.write(8);Serial.write(32);Serial.write(8);}}else{Serial.write(serbuf[slen]);} 
      //Serial.print(slen);Serial.print('\t');Serial.write(ubuf[slen]);Serial.print('\t');Serial.println(ubuf[slen]);
      slen++;
    }
    checkReset();
  }
  slen--;                             //remove last character (CR) and replace with string terminator
  serbuf[slen]='\0';                  //terminate the serial buffer string
  
  if(serbuf[0]=='k'&&serbuf[1]==' '){ //trs-80 keyboard typing hack
    Serial.print(F("\r\n"));
    for(byte i=2; i<slen; i++){
        Serial.print(char(serbuf[i]));
        if(serbuf[i]=='\\'){
        i++;
        Serial.print(char(serbuf[i]));
        switch(serbuf[i]){
          case 'n': //returN or eNter key 13
            keypress(13);
            break;
          case 'c': //clear key 31
            keypress(31);
            break;
          case 'u': //up key 91
            keypress(91);
            break;
          case 'd': //down key 10
            keypress(10);
            break;
          case 'l': //left key 8
            keypress(8);
            break;
          case 'r': //right key 9
            keypress(9);
            break;
          case 'k': //break key 1
            keypress(1);
            break;
          }
        }else{
        keypress(serbuf[i]);
        }   
     }
     Serial.print(F("\r\n>"));
     return; 
  }
    
  verb=strtok(serbuf, delim);
  if(verb == NULL){ ok=1; }           //no command, just reprint > prompt
  nouns = 0;                          //seperate nouns
  char* nountemp;
  nountemp=strtok(NULL, delim);
  while(nountemp != NULL ){
      noun[nouns]=nountemp;
      nouns++;
      nountemp = strtok(NULL, delim);
      if(nouns>=nounnum-1){nouns=nounnum-1;} //set nounnum=2 --> reads up to 2 nouns for some reason, set nounnum=4 as workaround to get rd to work (check later)
  }
  char* pend;                         //used in strtol, normally not used
  //Serial.print(F("(nouns:"));Serial.print(nouns);Serial.print(')'); //for debugging, show number of nouns used
  Serial.print(F("\r\n"));
  
  //******************************************************************************************************************************
  
  if(0==strcmp_P(verb,PSTR("dir"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("List SD card files.\r\n"));
    }else{
    lsdir();
    }
  }
  if(0==strcmp_P(verb,PSTR("del"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Deletes file from SD card.\r\nUsage: del file.bin\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      SD.remove(noun[0]);
      Serial.print(F("Deleted "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("ks"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Types out a file on trs80 keyboard.\r\nUsage: ks file.asc\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      File sdFile = SD.open(noun[0]);
      while(sdFile.available()){
         keypress(sdFile.read());
      }
      sdFile.close();
      Serial.println(F("Done")); 
    }
  }

  if(0==strcmp_P(verb,PSTR("ls"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Lists local (shared) ram. \r\n"));
    }else{
    for(unsigned int a=0;a<=31;a++){
        if(a*2<16*16){Serial.print('0');}
        if(a==0){Serial.print('0');}
        if(a*2<16){Serial.print('0');} 
        Serial.print(a*2*16, HEX); Serial.print(F("  "));
        for(int b=0;b<=31;b++){
          byte t = srRead(a*32+b);
          if(b==16){Serial.print(' ');}
          if(t<16){Serial.print('0');}
          Serial.print(t, HEX); Serial.print(' ');
        }
        Serial.println();
      }
    }
  }
  if(0==strcmp_P(verb,PSTR("ll"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Loads a bin file to a location in local (shared) ram.\r\nUsage: ll file.bin hstartaddress\r\n"));
    }else if(nouns==0){localzero(); loadz80loader(); Serial.print(F("Loaded z80 loader program\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
    File sdFile = SD.open(noun[0]);
       unsigned int j=strtol(noun[1], &pend, 16);
       unsigned int i=j;
       while(sdFile.available()){
         srWrite(i,sdFile.read());
         i++;
       }
    sdFile.close();
    Serial.print(F("Loaded "));Serial.print(noun[0]);Serial.print(F(" to local "));printHex2(j);Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("ld"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Dumps local (shared) ram to file.\r\nUsage: ld file.bin hstartaddress hendaddress\tIf no addresses, uses whole ram.\r\n"));
    }else if(SD.exists(noun[0])){Serial.print(F("File exists: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      unsigned int tstart=0;
      unsigned int tend=1023;
      File sdFile = SD.open(noun[0], FILE_WRITE);
        for(unsigned int i=tstart;i<=tend;i++){
          sdFile.write(srRead(i));
        }
      sdFile.close();
      Serial.print(F("Read from local "));printHex2(tstart);Serial.print(F(" to local "));printHex2(tend);Serial.print(F(" >> "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("lr"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Reads single byte from local (shared) ram.\r\nUsage: lr haddress\r\n"));
    }else{
      printHex(srRead(strtol(noun[0], &pend, 16)));Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("lw"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Writes single byte from local (shared) ram.\r\nUsage: lw haddress hbyte\r\n"));
    }else{
      unsigned int addrQ = strtol(noun[0], &pend, 16);
      unsigned int dataQ = strtol(noun[1], &pend, 16);
      srWrite(addrQ, dataQ);
      Serial.print(F("Wrote "));printHex(srRead(addrQ));Serial.print(F(" to "));printHex2(addrQ);Serial.print(F("\r\n"));
    }
  }
  
  if(0==strcmp_P(verb,PSTR("p"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Pauses trs80.\r\n"));
    }else{
      srWrite(0x300,1);
    }
  }
  if(0==strcmp_P(verb,PSTR("r"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Exits z80 loader program on trs80/returns to standard operation.\r\n"));
    }else{
      z80Continue(); //Serial.println(F("z80 loader exited"));
    }
  }

  if(0==strcmp_P(verb,PSTR("j"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Jumps to a location in trs80 ram.\r\n"));
    }else{
      unsigned int addrQ = strtol(noun[0], &pend, 16);
      srWrite(0x303,highByte(addrQ));
      srWrite(0x302,lowByte(addrQ));
      srWrite(0x300,4);
      while(srRead(0x300)!=0){delayMicroseconds(150);}
      Serial.print(F("Jumped to "));printHex2(addrQ);Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("rl"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Loads a bin file to a location in trs80 ram.\r\nUsage: rl file.bin hstartaddress\t if no address, starts at h4000\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      unsigned long addrQ = 0;
      if(nouns<=1){addrQ = 0x4000;}else{addrQ = strtol(noun[1], &pend, 16);}
      Serial.print(F("Loading "));Serial.print(noun[0]);Serial.print(F(" to "));printHex2(addrQ);Serial.print(F("..."));
       File sdFile = SD.open(noun[0]);
          bool loadingQ = 1;
          while(sdFile.available() && loadingQ==1){
            if(addrQ%1024==0){Serial.print('.');}
            if(z80Write(addrQ, sdFile.read())==false){Serial.print(F("verify failed at "));printHex2(addrQ);Serial.print(F("\r\n")); loadingQ=0;}
            addrQ++;
          }
       sdFile.close();
       Serial.print(F("done\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("rs"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Lists some or all of trs80 ram.\r\nUsage: rs hstartaddress hendaddress\tIf no parameters, uses last start and end used.\r\n"));
    }else{
      if(nouns>=1){rsStart = strtol(noun[0], &pend, 16);}
      if(nouns>=2){rsEnd = strtol(noun[1], &pend, 16);}
      if(rsStart%32!=0){Serial.print(F("      "));}
      for(unsigned long i=rsStart;i<=rsEnd;i++){
        if(i%32==0){
          if(i!=rsStart){Serial.println();}
          if(i<16*16*16){Serial.print('0');}
          if(i<16*16){Serial.print('0');}
          if(i<16){Serial.print('0');} 
          Serial.print(i, HEX); Serial.print(F(" "));
        }
        if(i%16==0){Serial.print(F(" "));}
        byte a=z80Read(i);
        if(a<16){Serial.print('0');} Serial.print(a, HEX); Serial.print(' ');
      }
      Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("rd"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Dumps trs80 ram to file.\r\nUsage: rd file.bin hstartaddress hendaddress\tIf no addresses, uses last start and end used.\r\n"));
    }else if(SD.exists(noun[0])){Serial.print(F("File exists: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      if(nouns>=2){rsStart = strtol(noun[1], &pend, 16);}
      if(nouns>=3){rsEnd = strtol(noun[2], &pend, 16);}
      Serial.print(F("Reading from "));printHex2(rsStart);Serial.print(F(" to "));printHex2(rsEnd);Serial.print(F(" >> "));Serial.print(noun[0]);Serial.print(F("..."));
      File sdFile = SD.open(noun[0], FILE_WRITE);
      for(unsigned long i=rsStart;i<=rsEnd;i++){
        if(i%1024==0){Serial.print('.');}
        sdFile.write(z80Read(i));
      }
      sdFile.close();
      Serial.print(F("done\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("rv"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Verifies bin file with section of trs80 ram.\r\nUsage: rv file.bin hstartaddress\tIf no start address, starts at h4000\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      unsigned int addrQ=0;
      if(nouns>=2){addrQ = strtol(noun[1], &pend, 16);}else{addrQ=0x4000;}
      Serial.print(F("Verifying "));Serial.print(noun[0]);Serial.print(F(" at "));printHex2(addrQ);Serial.print(F("..."));
      File sdFile = SD.open(noun[0]);
        bool loadingQ = 1;
        while(sdFile.available() && loadingQ==1){
          if(addrQ%1024==0){Serial.print('.');}
          if(z80Read(addrQ)!=sdFile.read()){Serial.print(F("verify failed at "));printHex2(addrQ);Serial.print(F("\r\n")); loadingQ=0;}
          addrQ++;
        }
      sdFile.close();
      if(loadingQ==0){Serial.print(F("done verify ok."));}
      Serial.print(F("\r\n"));
    }
  }
  
  if(0==strcmp_P(verb,PSTR("rr"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Reads single byte from trs80 ram.\r\nUsage: rr haddress\r\n"));
    }else{
      printHex(z80Read(strtol(noun[0], &pend, 16)));
    }
  }
  if(0==strcmp_P(verb,PSTR("rw"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Writes single byte from trs80 ram.\r\nUsage: rw haddress hbyte\r\n"));
    }else{
      unsigned int addrQ=strtol(noun[0], &pend, 16);
      byte dataQ=strtol(noun[1], &pend, 16);
      z80Write(addrQ, dataQ);
      Serial.print(F("Wrote "));printHex(z80Read(addrQ));Serial.print(F(" to "));printHex2(addrQ);Serial.print(F("\r\n"));
    }
  }
  if(0==strcmp_P(verb,PSTR("xs"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Sends file over serial port.\r\nUsage: xs file.bin\r\n"));
    }else if(!SD.exists(noun[0])){Serial.print(F("No such file: "));Serial.print(noun[0]);Serial.print(F("\r\n"));
    }else{
      Serial.print(F("Press any key to start stream\r\n"));
      Serial.write(17); //xon
      while(!Serial.available()){} while(Serial.available()){Serial.read();}
        File sdFile = SD.open(noun[0]);
        while(sdFile.available()){
          Serial.write(sdFile.read());
        }
      delay(1500);
      //Serial.write(17); //xon
      while(!Serial.available()){}
      Serial.print(F("\r\nDone.\r\n"));
      sdFile.close();
    }
  }
  if(0==strcmp_P(verb,PSTR("xr"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Receives file over serial port.\r\nUsage: xr file.bin\r\n"));
    }else if(nouns<1){Serial.print(F("Must specify filename\r\n"));
    }else{
      Serial.print(F("READY:"));
      bool runxr=1;
      unsigned long ltime=millis()+120000;
      unsigned long sz=0;
      int bytec=0;
      byte ubuf[256]; //byte array for serial file transfer 
      File sdFile = SD.open(noun[0], FILE_WRITE);
      while(runxr){
        if(Serial.available()){
          ltime=millis()+1000;
          ubuf[bytec]=Serial.read();
          bytec++;
          sz++;
        }
        if(bytec>=255||ltime<millis()){
          Serial.write(19); //xoff
          for(int i=0; i<bytec; i++){
            sdFile.write(ubuf[i]);
          }
          bytec=0;
          if(ltime<millis()){runxr=0;}
          //delay(200);
          sdFile.flush();
          ltime=millis()+1000;
          Serial.write(17); //xon
        }
      }
      sdFile.close();
      Serial.write(17); //xon
      Serial.println();
      Serial.print(F("Done - "));Serial.println(sz);
    }
  }
  if(0==strcmp_P(verb,PSTR("cs"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Displays contents of trs-80 screen\r\nUsage: cs [r] - if r is given, cs will resume trs80 after execution\r\n"));
    }else{
      for(int lineQ=0; lineQ<=15; lineQ++){
        for(int colQ=0; colQ<=63; colQ++){
          Serial.write(z80Read(0x3c00+colQ+lineQ*64)); 
        }
        Serial.print(F("\r\n"));
      }
      if(nouns>=1&&0==strcmp_P(noun[0],PSTR("r"))){z80Continue();}
    }
  }
  
  if(0==strcmp_P(verb,PSTR("tstram"))){ok=1;
    if(nouns>=1&&0==strcmp_P(noun[0],PSTR("?"))){Serial.print(F("Tests 48K of system RAM. Usage: tstram loops\r\n"));
    }else{
      int loops=1;
      if(nouns>=1){loops = strtol(noun[0], &pend, 16);}
      Serial.println(F("Running..."));
      for(int j=0; j<=loops; j++){
        for(long c=0x4000; c<=0xffff; c++){
          if(z80Write(c, 0xff)==false){Serial.print(F("FF failed at "));printHex2(c);Serial.print(F("\r\n"));}
          if(z80Write(c, 0x00)==false){Serial.print(F("00 failed at "));printHex2(c);Serial.print(F("\r\n"));}
        }
      }
      if(nouns>=1&&0==strcmp_P(noun[0],PSTR("r"))){z80Continue();}
      Serial.println(F("Done."));
    }
  }

  if(0==strcmp_P(verb,PSTR("?"))){ok=1;
    Serial.print(F("Commands list:\r\n"));
    Serial.print(F("dir - list SD files\r\n")); 
    Serial.print(F("del - delete SD files\r\n"));
    Serial.print(F("ls - list local ram\r\n"));
    Serial.print(F("ll - load to local ram\r\n"));
    Serial.print(F("ld - dump local ram\r\n"));
    Serial.print(F("lr - write byte to local ram\r\n"));
    Serial.print(F("lw - read byte from local ram\r\n")); 
    Serial.print(F("p  - pause trs80\r\n"));
    Serial.print(F("r  - resume trs80\r\n")); 
    Serial.print(F("j  - JP to address\r\n"));
    Serial.print(F("rl - load to trs80 ram\r\n"));
    Serial.print(F("rs - list trs80 ram\r\n"));
    Serial.print(F("rd - dump trs80 ram\r\n"));
    Serial.print(F("rv - verify file against trs80 ram\r\n"));
    Serial.print(F("rr - read byte from trs80 ram\r\n"));
    Serial.print(F("rw - write byte to trs80 ram\r\n"));
    Serial.print(F("cs - display contents of trs80 screen\r\n"));
    Serial.print(F("xs - send raw file from SD over serial port\r\n"));
    Serial.print(F("xr - recv raw file to SD over serial port\r\n"));
    Serial.print(F("k  - type string on trs-80 keyboard\r\n"));
    Serial.print(F("ks - type file on trs-80 keyboard\r\n"));
    Serial.print(F("tstram - tests 48K of system RAM\r\n"));
  }

  if(ok==0){Serial.print(F("Command not found\r\n"));}
  Serial.print(F(">"));
}
