void srWriteRaw(unsigned int address, byte data){
  SPI.transfer16(address);
  PORTC |=  (1<<PC7); PORTC &= ~(1<<PC7);
  
  PORTC &= ~(1<<PC2); //select ram chip
  
  PORTA = data; //set data and output
  DDRA  = 0xff;
  __asm__("nop\n\t");  //delay only
  __asm__("nop\n\t");  //delay only
  PORTC &= ~(1<<PC3); //drop and release write pin
  __asm__("nop\n\t");  //delay only
  __asm__("nop\n\t");  //delay only
  PORTC |=  (1<<PC3);

  PORTC |=  (1<<PC2); //release ram chip
   
  DDRA  = 0x00; //data pins back to hi-z
  PORTA = 0xFF; //enable data pullups
}

void srWrite(unsigned int address1, byte data1){
  while(srRead(address1)!=data1){srWriteRaw(address1, data1);}
}

byte srRead(unsigned int address){
  byte data;
  SPI.transfer16(address);
  PORTC |=  (1<<PC7); PORTC &= ~(1<<PC7);
  PORTC &= ~(1<<PC2); //select ram chip
  __asm__("nop\n\t");  //delay only
  __asm__("nop\n\t");  //delay only
  PORTC &= ~(1<<PC4); //drop and release OE pin
  __asm__("nop\n\t");  //delay only
  __asm__("nop\n\t");  //delay only
  data = PINA;
  
  PORTC |=  (1<<PC4); 

  PORTC |=  (1<<PC2); //release ram chip
  return data;
}

void lsdir() {
  File dir = SD.open("/");
  dir.rewindDirectory();
  while(1){
    File entry=dir.openNextFile();
    if(!entry){dir.close(); break;}
    if(!entry.isDirectory()){
      Serial.print(entry.name());
      Serial.print(F(" - "));
      Serial.println(entry.size());
    }
    entry.close();
  }
}

void localzero(){for(int a=0;a<=1023;a++){ srWrite(a,0);}}
void loadz80loader(){for(unsigned int i=0;i<sizeof(z80loaderbin);i++){srWrite(i,pgm_read_byte(&z80loaderbin[i]));}}
//**********************************SUPPORT FUNCTIONS FOR Z80 LOADER PROGRAM************************************************
byte z80Read(unsigned int address){
  srWrite(0x303,highByte(address));
  srWrite(0x302,lowByte(address));
  srWrite(0x300,2);
  while(srRead(0x300)!=1){if(digitalRead(1)==0){return 0;}}
  byte a = srRead(0x301);
  return a;
}
bool z80Write(unsigned int address, byte data){
  srWrite(0x301,data);
  srWrite(0x303,highByte(address));
  srWrite(0x302,lowByte(address));
  srWrite(0x300,3);
  while(srRead(0x300)!=1){if(digitalRead(1)==0){return 0;}}
  if(z80Read(address)==data){return true;}
  return false;
}
void z80Continue(){ srWrite(0x300,0); }

unsigned long convertString(String input){ //converts a String from decimal(d123) hexadecimal(77) or binary(b101001) to integer.
  unsigned long output=0;
  if(input.length()==0){return 0;}
  if(input.charAt(0)=='d'){ //decimal
    input.remove(0,1);
    output = input.toInt();
  }else if(input.charAt(0)=='b'){
    input.remove(0,1);
    byte sst=0;
    while(sst<input.length()){
      byte oadd=255;
      if(input.charAt(sst)=='0'){oadd=0;}
      if(input.charAt(sst)=='1'){oadd=1;}
      if(oadd!=255){output=output*2+oadd;}
      sst++; 
    }
  }else{
    byte sst=0;
    while(sst<input.length()){
      byte oadd=255;
      if(input.charAt(sst)=='0'){oadd=0;}
      if(input.charAt(sst)=='1'){oadd=1;}
      if(input.charAt(sst)=='2'){oadd=2;}
      if(input.charAt(sst)=='3'){oadd=3;}
      if(input.charAt(sst)=='4'){oadd=4;}
      if(input.charAt(sst)=='5'){oadd=5;}
      if(input.charAt(sst)=='6'){oadd=6;}
      if(input.charAt(sst)=='7'){oadd=7;}
      if(input.charAt(sst)=='8'){oadd=8;}
      if(input.charAt(sst)=='9'){oadd=9;}
      if(input.charAt(sst)=='a'){oadd=10;}
      if(input.charAt(sst)=='b'){oadd=11;}
      if(input.charAt(sst)=='c'){oadd=12;}
      if(input.charAt(sst)=='d'){oadd=13;}
      if(input.charAt(sst)=='e'){oadd=14;}
      if(input.charAt(sst)=='f'){oadd=15;}
      if(oadd!=255){output=output*16+oadd;}
      sst++;
    }
  }
  return output;
}
void printHex(byte input){
  Serial.print(F("0x"));
  if(input<16){Serial.print('0');}
  Serial.print(input, HEX);
  Serial.print(F(" ("));
  Serial.print(input);
  Serial.print(F(")"));
}
void printHex2(unsigned int input){
  Serial.print(F("0x"));
  if(input<16*16*16){Serial.print('0');}
  if(input<16*16){Serial.print('0');}
  if(input<16){Serial.print('0');}
  Serial.print(input, HEX);
  Serial.print(F(" ("));
  Serial.print(input);
  Serial.print(F(")"));
}

void keypress(byte k){
  srWrite(0x306, k);
  delay(50);
}
